from Products.CMFPlone.WorkflowTool import WorkflowTool
from Products.CMFPlacefulWorkflow.PlacefulWorkflowTool import WorkflowPolicyConfig_id
from Acquisition import aq_base, aq_parent, aq_inner

def getChainFor(self, ob):
    """
    monkey-patched by CMFPlacefulWorkflow to look for placeful workflow
    configurations.
    """
    cbt = self._chains_by_type

    if type(ob) == type(''):
        pt = ob
    elif hasattr(aq_base(ob), '_getPortalTypeName'):
        pt = ob._getPortalTypeName()
    else:
        pt = None

    if pt is None:
        return ()

    if type(ob) != type('') and pt!=None:
        # Inspired by implementation in CPSWorkflowTool.py of CPSCore 3.9.0
        wfpolicyconfig = getattr(ob, WorkflowPolicyConfig_id, None)
        if wfpolicyconfig is not None:
            # Was it here or did we acquire?
            start_here = hasattr(aq_base(aq_parent(aq_inner(ob))), WorkflowPolicyConfig_id)
            chain = wfpolicyconfig.getPlacefulChainFor(pt, start_here=start_here)
            if chain is not None:
                return chain

    chain = None
    if cbt is not None:
        chain = cbt.get(pt, None)
        # Note that if chain is not in cbt or has a value of
        # None, we use a default chain.
    if chain is None:
        chain = self.getDefaultChainFor(ob)
        if chain is None:
            return ()
    return chain

# don't lose the docstrings
getChainFor.__doc__ = '\n'.join((WorkflowTool.getChainFor.__doc__, getChainFor.__doc__))
WorkflowTool.getChainFor = getChainFor
